// complex_class.cpp
// Ex. 6.6: complex numbers using class w/this
//
#include <stdio.h>

class Complex {
private:
  float real, imag;
public:
  Complex( float = 0.0, float = 0.0);
  Complex & add( Complex, Complex);
  void print();
};

Complex & Complex::add( Complex a, Complex b )
{ real = a.real + b.real;
  imag = a.imag + b.imag;
  return *this;
}

Complex::Complex( float r, float i)
{ real = r; imag = i; }

void Complex::print()
{ printf("( %f, %f )",real,imag);
}

main()
{ Complex a(1.0,1.0), b(-1.0,1.0), c;
  a.print(); printf(" + "); b.print(); printf(" = ");
  c.add(a,b).print(); printf("\n");
  c.add(a,b).add(c,a).print(); printf("\n"); 
  return 0;
}

